#define BOOST_TEST_MODULE covariance_decomposition_test
#include <boost/test/included/unit_test.hpp>
#include <boost/numeric/ublas/symmetric.hpp>
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/io.hpp>

#include "../../src/atmos.h"
#include "../../src/covariance_decomposition.h"

BOOST_AUTO_TEST_CASE(eigen_weight_matrix_identity) {
	using namespace boost::numeric::ublas;
	using namespace utils::ublas;
	
	symmetric_matrix<double> covariance = identity_matrix<double>(70);
	std::pair< matrix<double>, matrix<double> > result = eigen_weight_matrix( covariance );
	
	BOOST_CHECK( covariance.size1() == result.first.size1() );
	BOOST_CHECK( covariance.size2() == result.first.size2() );
	
	for( unsigned int i = 0; i < result.first.size1(); ++i ) {
		for( unsigned int j = 0; j < result.first.size2(); ++j ) {
			BOOST_CHECK_CLOSE( result.first(i,j), ( i==j ? 1.0 : 0.0 ), 1e-5 );
		}
	}
}
