#define BOOST_TEST_MODULE indices_test
#include <boost/test/included/unit_test.hpp>
#include <boost/numeric/ublas/symmetric.hpp>
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/io.hpp>

#include "../../src/atmos.h"
#include "../../src/indices.h"

BOOST_AUTO_TEST_CASE( atmos_order ) {
	using namespace boost::numeric::ublas;
	using namespace atmos::indices;
	
	symmetric_matrix< double > ind(4,4);
	ind(0,0)=0;ind(1,1)=1;ind(2,2)=2;ind(3,3)=3;
	ind(0,1)=4;ind(0,2)=5;ind(0,3)=6;
	ind(1,2)=7;ind(1,3)=8;
	ind(2,3)=9;
	
	vector< double > vec=make_atmos_order(ind);
	std::cout << vec << std::endl;
	for( vector<double>::size_type i =0;i< vec.size();++i ){
		BOOST_CHECK( vec(i) == i );
	}
}