#ifndef _TRM_TRAITS_H
#define _TRM_TRAITS_H

#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/symmetric.hpp>

namespace trm {
	
namespace ublas = boost::numeric::ublas;

template<class T> struct type_traits {

	typedef T value_type;
	typedef ublas::vector< value_type > vector_type;
	typedef ublas::matrix< value_type > matrix_type;
	typedef ublas::symmetric_matrix< value_type > symmetric_matrix_type;
	
	typedef value_type function_type;
	typedef vector_type grad_type;
	typedef symmetric_matrix_type hesse_type;
};
}

#endif // _TRM_TRAITS_H
