#ifndef _TEST_ROSENBROCK_H
#define _TEST_ROSENBROCK_H

#include <boost/tuple/tuple.hpp>
#include <boost/numeric/ublas/symmetric.hpp>
#include <boost/numeric/ublas/vector.hpp>

namespace ublas = boost::numeric::ublas;


struct rosenbrock {
	
	rosenbrock() {}

        boost::tuple< double, ublas::vector<double>, ublas::symmetric_matrix<double> > operator() (const ublas::vector<double>& x) const {
		using std::pow;
		
		double function = pow(1.0-x(0),2.0)+100*pow(x(1)-x(0)*x(0),2.0);
		ublas::vector<double> grad(2);
		grad(0) = -2*(1.0-x(0))-400*(x(1)-x(0)*x(0))*x(0);
		grad(1) = 200*(x(1)-x(0)*x(0));
		
		ublas::symmetric_matrix<double> hesse(2,2);
		
		hesse(0,0) = 2-400*x(1)+1200*x(0)*x(0);
		hesse(0,1)=-400*x(0);
		hesse(1,1)=200;
		
		return boost::make_tuple(function,grad,hesse);
	}
};

#endif
